(define expire-list '()) ; where all of the processes go when they are done.
(define used-time 0) ; the ammount of time that is used in actual processing by the processesor

(define run-block
; This function takes a set of processes and runs through them giving
; them as much time as they will take.
; if they expire they will be put in the expire-list
	(lambda (numcycle proclst)
		(if (or (<= numcycle 0) (null? proclst))
			numcycle
			(let*
				((executecyc 
					(let 
						((numcyc (floor (* (/ ((process-memcall (car proclst))) 100) numcycle))))
							(if (> numcyc numcycle) numcycle numcyc)
							))
				 (runengret ((process-engine (car proclst)) 
						(cycles->enginetime executecyc)
						(lambda (ticks value) value) 
						(lambda (x) x)
						)
					)
				 )
				(if (list? runengret)
					(begin
						(set-process-output! (car proclst) runengret)
						(set-process-engine! (car proclst) 'elvisrocks)
						(set! expire-list (cons (car proclst) expire-list))
						)
					(set-process-engine! (car proclst) runengret)
					)
				(run-block (- numcycle executecyc) (schedule-realtime proclst))
				)
			)
		)
	)

; (define processes_running '())

(define simulate
; This is the main function for the whole program, it simulates the
; core of the processes, in it's first run (ie, actual users interface)
; it should probably be run with the second and third arguements as
; null lists.  When it completes it will return the symbol 'done' and
; have all of the processes originally passed in in the expire-list
	(lambda (unrun-in-proc running-proc cpu-in-proc)
		(if (and (null? unrun-in-proc) (null? running-proc) (null? cpu-in-proc)) 'done
			(let*
				((tempvar (start-proc global-time unrun-in-proc))
				 (run-t-proc (append running-proc (cadr tempvar)))
				 (urun-proc (car tempvar))
				 (tempvartoo (schedule run-t-proc cpu-in-proc))
				 (run-proc (car tempvartoo))
				 (cpu-proc (cadr tempvartoo))
				 (execution-time (- frame-size (run-block frame-size cpu-proc)))
				 )
;				(set! processes_running (cons (+ (length run-proc) (length cpu-proc)) processes_running))
				(set! global-time (+ global-time frame-size))     
				(set! used-time (+ used-time execution-time))
				(set! os-stack (prune-expired os-stack))
				(simulate urun-proc (prune-expired run-proc) (prune-expired cpu-proc))
				)
			)
		)
	)

(define prune-expired
	(lambda (proclst)
		(letrec
			((helper
				(lambda (proclst retlst)
					(if (null? proclst) (reverse retlst)
						(if (eq? (process-engine (car proclst)) 'elvisrocks)
							(helper (cdr proclst) retlst)
							(helper (cdr proclst) (cons (car proclst) retlst))
							)
						)
					)
				))
			(helper proclst '())
			)
		)
	)

;(define process_launch '())

(define start-proc 
; This function figures out what processes should be started and returns
; them, along with the new list of unstarted processes.
	(lambda (in-time proclst)
		(letrec
			((helper 
				(lambda (proclst retlst)
					(if (null? proclst) (list '() retlst)
						(if (< (process-starttime (car proclst)) in-time)
							(begin
								(set-process-engine! (car proclst) (process->engine (car proclst)))
								(helper (cdr proclst) (cons (car proclst) retlst))
								)
							(list proclst retlst)
							)
						)
					)
				))
			(let
				((retlst (helper proclst '())))
;				(set! process_launch (cons (length (cadr retlst)) process_launch))
				retlst
				)
			)
		)
	)
