(define average
     (lambda (lst)
          (/ (apply + lst) (length lst))
          )
     )

(define process-turnarround
     (lambda (proc)
          (- (process-finishtime proc) (process-starttime proc))
          )
     )

(define process-finishtime
     (lambda (proc)
          (+ (caar (process-output proc)) (cadar (process-output proc)))
          )
     )

(define process-realstarttime
     (lambda (proc)
          (caar (reverse (process-output proc)))
          )
     )

(define process-responcetime
     (lambda (proc)
          (- (process-realstarttime proc) (process-starttime proc))
          )
     )

(define process-waittime
     (lambda (proc)
          (letrec
               ((helper
                    (lambda (last next accum)
                         (if (null? next) accum
                              (helper (car next) (cdr next)
                                   (+ accum (- (caar next) (+ (- (cadr last) (cadar next)) (car last))))
                                   )
                              )
                         )
                    )
                (outrev (reverse (process-output proc)))
                )
               (helper (car outrev) (cdr outrev) '0)
               )
          )
     )
               
(printf "[")
;(printf "Total Time: ~a~%" (apply + (map process-cycles dataset)))
;(printf "Number of Proc: ~a~%" (length dataset))
;(printf "Density of Start Times: ~a~%" 'idontknow)
;(printf "~%")
(printf "~a, " (exact->inexact (* (/ used-time global-time) 100)))
;(printf "CPU Utilization: ~a~%" (* (/ used-time global-time) 100))
(printf "~a, ~a, ~a, " (apply min (map process-turnarround dataset)) (average (map process-turnarround dataset)) (apply max (map process-turnarround dataset)))
;(printf "Turn Arround: ~a, ~a, ~a~%" (apply min (map process-turnarround dataset)) (average (map process-turnarround dataset)) (apply max (map process-turnarround dataset)))
(printf "~a, ~a, ~a, " (apply min (map process-responcetime dataset)) (average (map process-responcetime dataset)) (apply max (map process-responcetime dataset)))
;(printf "Responce time: ~a, ~a, ~a~%" (apply min (map process-responcetime dataset)) (average (map process-responcetime dataset)) (apply max (map process-responcetime dataset)))
(printf "~a, ~a, ~a, " (apply min (map process-waittime dataset)) (average (map process-waittime dataset)) (apply max (map process-waittime dataset)))
;(printf "Wait time: ~a, ~a, ~a~%" (apply min (map process-waittime dataset)) (average (map process-waittime dataset)) (apply max (map process-waittime dataset)))
(printf "~a, " (exact->inexact (/ (length dataset) global-time)))
;(printf "Throughput: ~a~%" (/ (length dataset) global-time))
(printf "~a" (- (length expire-list) (length dataset)))
;(printf "OS Calls: ~a~%" (- (length expire-list) (length dataset)))

(define print-sequencial
	(lambda (lst)
		(if (null? lst) '()
			(begin
				(printf "~a, " (car lst))
				(print-sequencial (cdr lst))
				)
			)
		)
	)

(printf "]~%")

(printf "[")
(printf "5")
;(print-sequencial (reverse processes_running))
(printf "]~%[")
(printf "5")
;(print-sequencial (reverse process_launch))
(printf "]~%")
