function graphdata = getgraph(dataset, memory_calls, os_calls, context_switchs, frame_sizes, schedulers, datatype)
%     function getgraph
%
%  This function graphs scheduling data for the Ted Gould
% SMT scheduler.  The six parameters (yes six) are mostly values
% except for the first and last which are these values:
%    dataset:     1 - dataset_long1.ss
%                 2 - dataset_long2.ss
%
%    scheduler:   1 - schedule_one.ss
%                 2 - schedule_shift.ss
%

numberofentries = length(dataset) * length(memory_calls) * length(os_calls) * length(context_switchs) * length(frame_sizes) * length(schedulers);
graphdata = zeros(1, numberofentries);
x = 1;

for ds = dataset
for mc = memory_calls
for oc = os_calls
for cs = context_switchs
for fs = frame_sizes
for sc = schedulers

	varfp = fopen('/tmp/ted.variables.ss', 'w');	
	fprintf(varfp, '(define frame-size %d)\n', fs);
	fprintf(varfp, '(define context-switch-time %d)\n\n', cs);
	fprintf(varfp, '(define memory-calls %d)\n', mc);
	fprintf(varfp, '(define os-calls %d)\n', oc);
	fprintf(varfp, '(define os-length %d)\n\n', 200);
	fprintf(varfp, '(define scheduler \"%s\")\n', getscheduler(sc));
	fprintf(varfp, '(define dataset \"%s\")\n', getdataset(ds));
	fclose(varfp);

	getdata;

	graphdata(x) = stats(datatype);
	x = x + 1;

end % sc
end % fs
end % cs
end % oc
end % mc
end % ds

bob = 5;
