function bob = getgraph(dataset, memory_calls, os_calls, context_switchs, frame_sizes, datatype)

if (length(dataset) > 1)
	varied = dataset;
	xlab = 'Dataset Number';
	end
if (length(memory_calls) > 1)
	varied = memory_calls;
	xlab = 'Memory Call Percentage';
	end
if (length(os_calls) > 1)
	varied = os_calls;
	xlab = 'OS Call Percentage';
	end
if (length(context_switchs) > 1)
	varied = context_switchs;
	xlab = 'Context Switch Time';
	end
if (length(frame_sizes) > 1)
	varied = frame_sizes;
	xlab = 'Frame Size';
	end

datafile = zeros(5, length(varied));

for i = 1:5
	datafile(i, :) = getgraph(dataset, memory_calls, os_calls, context_switchs, frame_sizes, i, datatype);
	end

figure;
;plot(varied, datafile(1, :), varied, datafile(2, :), varied, datafile(3, :), varied, datafile(4, :), varied, datafile(5, :));
;legend('Traditional', 'Shift In', 'Top', 'Shift In Persistant', 'Top Persistant', 0);
plot(varied, datafile(2, :)./datafile(1,:), '-', varied, datafile(3, :)./datafile(1,:), ':', varied, datafile(4, :)./datafile(1,:), '-.', varied, datafile(5, :)./datafile(1,:), '--');
legend('Shift In', 'Top', 'Shift In Persistant', 'Top Persistant', 0);
xlabel(xlab);

switch datatype
	case 1,
		ylabel('CPU Usage');
	case 2,
		ylabel('Min Turnarround Time');
	case 3,
		ylabel('Average Turnarround Time');
	case 4,
		ylabel('Max Turnarround Time');
	case 5,
		ylabel('Min Responce Time');
	case 6,
		ylabel('Average Responce Time');
	case 7,
		ylabel('Max Responce Time');
	case 8,
		ylabel('Min Wait Time');
	case 9,
		ylabel('Average Wait Time');
	case 10,
		ylabel('Max Wait Time');
	case 11,
		ylabel('Troughput');
	case 12,
		ylabel('Number of OS Calls');
	end


bob = datafile;
