(define global-time '0) ; the 'time' it is to everyone

(define run-func
; This is the function that processes run to continue going.  This is
; the function that checks on all of the OS calls.
     (lambda (numcycles lasttime retlst inprocess)
          (if (eq? numcycles 0)
               retlst
               (if (< (random 100) (process-oscall inprocess))
                    (begin
                         (os-makecall (process-oscalllength inprocess))
                         (engine-block)
                         (run-func (- numcycles 1) lasttime retlst inprocess)
                         )
                    (run-func (- numcycles 1) global-time
                              (if (eq? lasttime global-time)
                                   retlst
                                   (cons (list global-time numcycles) retlst)
                                   )
                              inprocess
                              )
                    )
               )
          )
     )

(define process->engine
; This takes in a process record and then creates it's engine to be
; run by the simulation
     (lambda (proc)
          (make-engine
               (lambda ()
                    (run-func
                         (process-cycles proc)
                         '-1
                         '()
                         proc
                         )
                    )
               )
          )
     )
     
(define cycles->enginetime
; Because run-fun isn't just one cycle this is the conversion factor
; from 'logical' units to 'engine units' that are used by scheme.
     (lambda (cyc)
          (* cyc 28)
          )
     )
