(define-record process (
          oscall ; the percent of time the function makes os calls
          oscalllength ; the number of cycles for the average os call
          cycles ; the number of cycles the process will use
          id ; this is an inique id number
          output ; the return of the whole thing
          engine ; this is what is run
          memcall ; a function to return...
          starttime ; the time the proc starts
          )
     )

(define make-data-set
     (lambda (
			 start_time     ; The time that they start generating from
			 start_id       ; The first id number to use
          proc-num       ; number of procs to generate
          proc-space     ; the spacing between them
          run-length     ; average running time +- 10%
          mem-usage ; again +- 10%
          os-call        ; again +- 10%
          os-call-l ; length of said os calls
          )
          (letrec
               ((helper (lambda (curtime proc-num cur-id retlst)
                              (if (eq? 0 proc-num) (reverse retlst)
                                   (helper
                                        (+ curtime proc-space)
                                        (- proc-num 1)
                                        (+ cur-id 1)
                                        (cons
                                             (let
                                                  ((runt (+ run-length (* run-length (/ (- (random 20) 10) 100)))))
                                                  (make-process
                                                       os-call
                                                       os-call-l
                                                       runt
                                                       cur-id
                                                       'null
                                                       'null
                                                       (lambda () (+ mem-usage (* mem-usage (/ (- (random 20) 10) 100))))
                                                       curtime
                                                       )
                                                  )
                                             
                                             retlst)
                                        )
                                   )
                         )
                    ))
               (helper start_time proc-num start_id '())
               )
          )
     )
