; This scheduling program goes through and shifts in the processes as
; they become available

(define shift-last -10)

(define removenegones
     (lambda (lst)
          (letrec
               ((helper  
                    (lambda (lst retlst)
                         (if (null? lst) (reverse retlst)
                              (if (eq? -1 (car lst))
                                   (helper (cdr lst) retlst)
                                   (helper (cdr lst) (cons (car lst) retlst))
                                   )
                              )
                         )
                    ))
               (helper lst '())
               )
          )
     )


(define schedule
     (lambda (os_proc processor_proc)
          (if (and (null? os_proc) (null? processor_proc))
               (list '() '())
               (let
                    ((proclst (append processor_proc os_proc))
                     (origid (sort < (map process-id processor_proc)))
                     )
                    (if (eq? (process-id (car proclst)) shift-last)
                         (set! proclst (append (cdr proclst) (list (car proclst))))
                         '()
                         )
                    (set! shift-last (process-id (car proclst)))
                    (set! proclst (append os-stack proclst))
                    (set! os-stack '())
                    (letrec
                         ((helper 
                              (lambda (proclst retlst number)
                                   (if (null? proclst)
                                        (list '() retlst)
                                        (if (eq? number 0)
                                             (list proclst retlst)
                                             (helper (cdr proclst) (cons (car proclst) retlst) (- number 1))
                                             )
                                        )
                                   )
                              ))
                         (letrec
                              ((retlst (helper proclst '() 4))
                               (countdiff
                                   (lambda (number lsta lstb)
                                        (if (or (null? lsta) (null? lstb)) number
                                             (if (eq? (car lsta) (car lstb))
                                                  (countdiff (- number 1) (cdr lsta) (cdr lstb))
                                                  (if (< (car lsta) (car lstb))
                                                       (countdiff number (cdr lsta) lstb)
                                                       (countdiff number lsta (cdr lstb))
                                                       )
                                                  )
                                             )
                                        )
                                   )
                               )
                              (set! global-time (+ global-time (* context-switch-time (countdiff 4 (removenegones origid) (removenegones (sort < (map process-id (cadr retlst))))))))
                              retlst
                              )
                         )
                    )
               )
          )
     )

(define schedule-realtime
     (lambda (proc-list)
          (if (null? os-stack)
               (cdr proc-list)
               (let
                    ((ret (append os-stack proc-list)))
                    (set! os-stack '())
                    ret
                    )
               )
          )
     )
